unit DragObject;

{$mode ObjFPC}{$H+}

interface

uses
  Classes, SysUtils, Controls, Graphics;

type

  { TTextDragObject }

  TTextDragObject = class(TDragControlObject)
  private
    FDragImages: TDragImageList;
  protected
    function GetDragImages: TDragImageList; override;
  public
    constructor Create(AControl: TControl; const AText: String); overload;
    destructor Destroy; override;
  end;

implementation

{ TTextDragObject }

function TTextDragObject.GetDragImages: TDragImageList;
begin
  Result := FDragImages;
end;

constructor TTextDragObject.Create(AControl: TControl; const AText: String);
var
  Bitmap: TBitmap;
  AWidth: Integer;
  AHeight: Integer;
begin
  inherited Create(AControl);
  FDragImages := TDragImageList.Create(AControl);
  AlwaysShowDragImages := True;

  AWidth := 0;
  AHeight := 0;
  Bitmap := TBitmap.Create;
  Bitmap.Canvas.Clear;
  Bitmap.Canvas.GetTextSize(AText, AWidth, AHeight);
  Bitmap.SetSize(AWidth, AHeight);
  Bitmap.Canvas.Clear;
  Bitmap.Canvas.TextOut(0, 0, AText);

  FDragImages.Width := AWidth;
  FDragImages.Height := AHeight;
  FDragImages.Add(Bitmap, nil);
  FDragImages.DragHotspot := Point(AWidth div 2, AHeight div 2);

  Bitmap.Free;
end;

destructor TTextDragObject.Destroy;
begin
  FDragImages.Free;
  inherited Destroy;
end;

end.

