unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ComCtrls, DragObject,
  ExtCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    ListView1: TListView;
    DragTimer: TTimer;
    DropPanel: TPanel;
    procedure DragTimerTimer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ListView1DragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure ListView1DragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure ListView1StartDrag(Sender: TObject; var DragObject: TDragObject);
  private
    FDragObject: TTextDragObject;
    FDragItem: TListItem;
    FDropBeforeItem: TListItem;
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
var
  i: Integer;
begin
  for i := 0 to 99 do
    ListView1.AddItem('Item' + i.ToString, nil);
  ListView1.DragMode := dmAutomatic;
end;

procedure TForm1.DragTimerTimer(Sender: TObject);
var
  LRect: TRect;
begin
  if not Assigned(FDropBeforeItem) or not ListView1.Dragging then
  begin
    DragTimer.Enabled := False;
    DropPanel.Visible := False;
    Exit;
  end;
  LRect := FDropBeforeItem.DisplayRect(drBounds);
  LRect.Height := 2;
  DropPanel.BoundsRect := LRect;
  DropPanel.Visible := True;
end;

procedure TForm1.ListView1DragDrop(Sender, Source: TObject; X, Y: Integer);
begin
  FDropBeforeItem := ListView1.GetItemAt(X, Y);
  if not Assigned(FDropBeforeItem) then
  begin
    ListView1.Repaint;
    Exit;
  end;
  ListView1.Items.Move(ListView1.Items.IndexOf(FDragItem), ListView1.Items.IndexOf(FDropBeforeItem));
  FDropBeforeItem := nil;
  FDragItem := nil;
end;

procedure TForm1.ListView1DragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
  Accept := True;
  FDropBeforeItem := ListView1.GetItemAt(X, Y);
  if not Assigned(FDropBeforeItem) then Exit;
  DragTimer.Enabled := True;
end;

procedure TForm1.ListView1StartDrag(Sender: TObject; var DragObject: TDragObject);
begin
  FreeAndNil(FDragObject);
  FDragItem := ListView1.Selected;
  if not Assigned(FDragItem) then Exit;
  FDragObject := TTextDragObject.Create(TControl(Sender), FDragItem.Caption);
  DragObject := FDragObject;
end;

end.

